/* LabelWithWidgets.c generated by valac 0.56.17, the Vala compiler
 * generated from LabelWithWidgets.vala, do not modify */

/* LabelWithWidgets is ported from Fractal*/
/* https://gitlab.gnome.org/GNOME/fractal/-/blob/3f8a7e8bd06441d83a5f052a2ae68d7d228dfcd0/src/components/label_with_widgets.rs*/
/* How to use:*/
/* Set `text` to the label's content but use the `placeholder` keyword where widgets should be placed.*/
/* Then use `set_children` with an array of Widgets in order of how they should be placed in the label.*/
/* There are some helper functions like `append_child` to add children and*/
/* `LabelWithWidgets.with_label_and_widgets` to construct it with the desired text and widgets.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>

#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER "\xEF\xBF\xBC"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS (tuba_widgets_label_with_widgets_get_type ())
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets))
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgetsClass))
#define TUBA_WIDGETS_IS_LABEL_WITH_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS))
#define TUBA_WIDGETS_IS_LABEL_WITH_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS))
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgetsClass))

typedef struct _TubaWidgetsLabelWithWidgets TubaWidgetsLabelWithWidgets;
typedef struct _TubaWidgetsLabelWithWidgetsClass TubaWidgetsLabelWithWidgetsClass;
typedef struct _TubaWidgetsLabelWithWidgetsPrivate TubaWidgetsLabelWithWidgetsPrivate;

#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_TYPE_LWW_WIDGET (tuba_widgets_label_with_widgets_lww_widget_get_type ())
typedef struct _TubaWidgetsLabelWithWidgetsLWWWidget TubaWidgetsLabelWithWidgetsLWWWidget;
enum  {
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_0_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_FIX_OVERFLOW_HACK_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACCESSIBLE_TEXT_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_LABEL_TEXT_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_PROPERTIES
};
static GParamSpec* tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
#define __vala_PangoLayoutRun_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoLayoutRun_free (var), NULL)))
#define __vala_PangoLayoutIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoLayoutIter_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_SIGNALS
};
static guint tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_SIGNALS] = {0};

struct _TubaWidgetsLabelWithWidgets {
	GtkWidget parent_instance;
	TubaWidgetsLabelWithWidgetsPrivate * priv;
	GtkLabel* label;
};

struct _TubaWidgetsLabelWithWidgetsClass {
	GtkWidgetClass parent_class;
};

struct _TubaWidgetsLabelWithWidgetsLWWWidget {
	GtkWidget* widget;
	gint height;
	gint width;
};

struct _TubaWidgetsLabelWithWidgetsPrivate {
	TubaWidgetsLabelWithWidgetsLWWWidget* widgets;
	gint widgets_length1;
	gint _widgets_size_;
	gchar* _placeholder;
	gchar* _label_text;
	gchar* _text;
	gboolean _use_markup;
	gboolean _fix_overflow_hack;
	gchar* _accessible_text;
	gboolean _ellipsize;
};

static gint TubaWidgetsLabelWithWidgets_private_offset;
static gpointer tuba_widgets_label_with_widgets_parent_class = NULL;
static GtkBuildableIface * tuba_widgets_label_with_widgets_gtk_buildable_parent_iface = NULL;
static GtkAccessibleInterface * tuba_widgets_label_with_widgets_gtk_accessible_parent_iface = NULL;

VALA_EXTERN GType tuba_widgets_label_with_widgets_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TubaWidgetsLabelWithWidgets, g_object_unref)
static GType tuba_widgets_label_with_widgets_lww_widget_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static TubaWidgetsLabelWithWidgetsLWWWidget* tuba_widgets_label_with_widgets_lww_widget_dup (const TubaWidgetsLabelWithWidgetsLWWWidget* self);
static void tuba_widgets_label_with_widgets_lww_widget_free (TubaWidgetsLabelWithWidgetsLWWWidget* self);
static void tuba_widgets_label_with_widgets_lww_widget_copy (const TubaWidgetsLabelWithWidgetsLWWWidget* self,
                                                      TubaWidgetsLabelWithWidgetsLWWWidget* dest);
static void tuba_widgets_label_with_widgets_lww_widget_destroy (TubaWidgetsLabelWithWidgetsLWWWidget* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TubaWidgetsLabelWithWidgetsLWWWidget, tuba_widgets_label_with_widgets_lww_widget_destroy)
static void _vala_TubaWidgetsLabelWithWidgetsLWWWidget_array_free (TubaWidgetsLabelWithWidgetsLWWWidget * array,
                                                            gssize array_length);
static void tuba_widgets_label_with_widgets_allocate_shapes (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN const gchar* tuba_widgets_label_with_widgets_get_text (TubaWidgetsLabelWithWidgets* self);
static void tuba_widgets_label_with_widgets_allocate_children (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_ellipsize (TubaWidgetsLabelWithWidgets* self);
static PangoLayoutRun* _vala_PangoLayoutRun_copy (PangoLayoutRun* self);
static gint tuba_widgets_label_with_widgets_pango_pixels (TubaWidgetsLabelWithWidgets* self,
                                                   gint d,
                                                   gint a);
static void _vala_PangoLayoutRun_free (PangoLayoutRun* self);
static void _vala_PangoLayoutIter_free (PangoLayoutIter* self);
static void tuba_widgets_label_with_widgets_real_size_allocate (GtkWidget* base,
                                                         gint width,
                                                         gint height,
                                                         gint baseline);
static GtkSizeRequestMode tuba_widgets_label_with_widgets_real_get_request_mode (GtkWidget* base);
static void tuba_widgets_label_with_widgets_real_measure (GtkWidget* base,
                                                   GtkOrientation orientation,
                                                   gint for_size,
                                                   gint* minimum,
                                                   gint* natural,
                                                   gint* minimum_baseline,
                                                   gint* natural_baseline);
static void tuba_widgets_label_with_widgets_update_label (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN const gchar* tuba_widgets_label_with_widgets_get_placeholder (TubaWidgetsLabelWithWidgets* self);
static void tuba_widgets_label_with_widgets_update_accessible_label (TubaWidgetsLabelWithWidgets* self);
static void tuba_widgets_label_with_widgets_invalidate_child_widgets (TubaWidgetsLabelWithWidgets* self);
static void tuba_widgets_label_with_widgets_set_accessible_text (TubaWidgetsLabelWithWidgets* self,
                                                          const gchar* value);
VALA_EXTERN const gchar* tuba_widgets_label_with_widgets_get_accessible_text (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_append_child (TubaWidgetsLabelWithWidgets* self,
                                                   GtkWidget* child);
static void _vala_array_add72 (TubaWidgetsLabelWithWidgetsLWWWidget* * array,
                        gint* length,
                        gint* size,
                        const TubaWidgetsLabelWithWidgetsLWWWidget* value);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_new_with_label_and_widgets (const gchar* t_text,
                                                                                         GtkWidget** t_widgets,
                                                                                         gint t_widgets_length1);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_construct_with_label_and_widgets (GType object_type,
                                                                                               const gchar* t_text,
                                                                                               GtkWidget** t_widgets,
                                                                                               gint t_widgets_length1);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_text (TubaWidgetsLabelWithWidgets* self,
                                               const gchar* value);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_children (TubaWidgetsLabelWithWidgets* self,
                                                   GtkWidget** t_widgets,
                                                   gint t_widgets_length1);
static void tuba_widgets_label_with_widgets_real_add_child (GtkBuildable* base,
                                                     GtkBuilder* builder,
                                                     GObject* child,
                                                     const gchar* type);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_grab_focus (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_new (void);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_construct (GType object_type);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_placeholder (TubaWidgetsLabelWithWidgets* self,
                                                      const gchar* value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_use_markup (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_use_markup (TubaWidgetsLabelWithWidgets* self,
                                                     gboolean value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_fix_overflow_hack (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_fix_overflow_hack (TubaWidgetsLabelWithWidgets* self,
                                                            gboolean value);
VALA_EXTERN const gchar* tuba_widgets_label_with_widgets_get_label_text (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_single_line_mode (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_single_line_mode (TubaWidgetsLabelWithWidgets* self,
                                                           gboolean value);
VALA_EXTERN gfloat tuba_widgets_label_with_widgets_get_xalign (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_xalign (TubaWidgetsLabelWithWidgets* self,
                                                 gfloat value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_selectable (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_selectable (TubaWidgetsLabelWithWidgets* self,
                                                     gboolean value);
VALA_EXTERN gint tuba_widgets_label_with_widgets_get_lines (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_lines (TubaWidgetsLabelWithWidgets* self,
                                                gint value);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_ellipsize (TubaWidgetsLabelWithWidgets* self,
                                                    gboolean value);
VALA_EXTERN GtkJustification tuba_widgets_label_with_widgets_get_justify (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_justify (TubaWidgetsLabelWithWidgets* self,
                                                  GtkJustification value);
static void g_cclosure_user_marshal_BOOLEAN__STRING (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GObject * tuba_widgets_label_with_widgets_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static gboolean _tuba_widgets_label_with_widgets___lambda27_ (TubaWidgetsLabelWithWidgets* self,
                                                       const gchar* url);
static gboolean __tuba_widgets_label_with_widgets___lambda27__gtk_label_activate_link (GtkLabel* _sender,
                                                                                const gchar* uri,
                                                                                gpointer self);
static void tuba_widgets_label_with_widgets_finalize (GObject * obj);
static GType tuba_widgets_label_with_widgets_get_type_once (void);
static void _vala_tuba_widgets_label_with_widgets_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_tuba_widgets_label_with_widgets_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);

static inline gpointer
tuba_widgets_label_with_widgets_get_instance_private (TubaWidgetsLabelWithWidgets* self)
{
	return G_STRUCT_MEMBER_P (self, TubaWidgetsLabelWithWidgets_private_offset);
}

static void
_vala_TubaWidgetsLabelWithWidgetsLWWWidget_array_free (TubaWidgetsLabelWithWidgetsLWWWidget * array,
                                                       gssize array_length)
{
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	if (array != NULL) {
#line 247 "LabelWithWidgets.c"
		gssize i;
#line 17 "../src/Widgets/LabelWithWidgets.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 17 "../src/Widgets/LabelWithWidgets.vala"
			tuba_widgets_label_with_widgets_lww_widget_destroy (&array[i]);
#line 253 "LabelWithWidgets.c"
		}
	}
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	g_free (array);
#line 258 "LabelWithWidgets.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 282 "LabelWithWidgets.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 290 "LabelWithWidgets.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 296 "LabelWithWidgets.c"
	}
}

static void
tuba_widgets_label_with_widgets_allocate_shapes (TubaWidgetsLabelWithWidgets* self)
{
	gboolean child_size_changed = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp2_;
	gint _tmp2__length1;
	PangoAttrList* attrs = NULL;
	PangoAttrList* _tmp24_;
	gint index = 0;
	GtkLabel* _tmp50_;
	PangoAttrList* _tmp51_;
#line 92 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/Widgets/LabelWithWidgets.vala"
	child_size_changed = FALSE;
#line 95 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = tuba_widgets_label_with_widgets_get_text (self);
#line 95 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = _tmp0_;
#line 95 "../src/Widgets/LabelWithWidgets.vala"
	if (g_strcmp0 (_tmp1_, "") == 0) {
#line 95 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 325 "LabelWithWidgets.c"
	}
#line 96 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = self->priv->widgets;
#line 96 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2__length1 = self->priv->widgets_length1;
#line 96 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp2__length1 == 0) {
#line 333 "LabelWithWidgets.c"
		GtkLabel* _tmp3_;
#line 97 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = self->label;
#line 97 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_attributes (_tmp3_, NULL);
#line 98 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 341 "LabelWithWidgets.c"
	}
	{
		gint i = 0;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 347 "LabelWithWidgets.c"
		{
			gboolean _tmp4_ = FALSE;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
			_tmp4_ = TRUE;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 354 "LabelWithWidgets.c"
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp6_;
				gint _tmp6__length1;
				GtkRequisition size = {0};
				GtkRequisition natural_size = {0};
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp7_;
				gint _tmp7__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp8_;
				GtkWidget* _tmp9_;
				GtkRequisition _tmp10_ = {0};
				GtkRequisition _tmp11_ = {0};
				gint width = 0;
				GtkRequisition _tmp12_;
				gint height = 0;
				GtkRequisition _tmp13_;
				gint old_width = 0;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp14_;
				gint _tmp14__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp15_;
				gint old_height = 0;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp16_;
				gint _tmp16__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp17_;
				gboolean _tmp18_ = FALSE;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp4_) {
#line 380 "LabelWithWidgets.c"
					gint _tmp5_;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
					_tmp5_ = i;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp5_ + 1;
#line 386 "LabelWithWidgets.c"
				}
#line 101 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = FALSE;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
				_tmp6_ = self->priv->widgets;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
				_tmp6__length1 = self->priv->widgets_length1;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp6__length1)) {
#line 101 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 398 "LabelWithWidgets.c"
				}
#line 104 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7_ = self->priv->widgets;
#line 104 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7__length1 = self->priv->widgets_length1;
#line 104 "../src/Widgets/LabelWithWidgets.vala"
				_tmp8_ = _tmp7_[i];
#line 104 "../src/Widgets/LabelWithWidgets.vala"
				_tmp9_ = _tmp8_.widget;
#line 104 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_get_preferred_size (_tmp9_, &_tmp10_, &_tmp11_);
#line 104 "../src/Widgets/LabelWithWidgets.vala"
				size = _tmp10_;
#line 104 "../src/Widgets/LabelWithWidgets.vala"
				natural_size = _tmp11_;
#line 105 "../src/Widgets/LabelWithWidgets.vala"
				_tmp12_ = natural_size;
#line 105 "../src/Widgets/LabelWithWidgets.vala"
				width = _tmp12_.width;
#line 106 "../src/Widgets/LabelWithWidgets.vala"
				_tmp13_ = natural_size;
#line 106 "../src/Widgets/LabelWithWidgets.vala"
				height = _tmp13_.height;
#line 108 "../src/Widgets/LabelWithWidgets.vala"
				_tmp14_ = self->priv->widgets;
#line 108 "../src/Widgets/LabelWithWidgets.vala"
				_tmp14__length1 = self->priv->widgets_length1;
#line 108 "../src/Widgets/LabelWithWidgets.vala"
				_tmp15_ = _tmp14_[i];
#line 108 "../src/Widgets/LabelWithWidgets.vala"
				old_width = _tmp15_.width;
#line 109 "../src/Widgets/LabelWithWidgets.vala"
				_tmp16_ = self->priv->widgets;
#line 109 "../src/Widgets/LabelWithWidgets.vala"
				_tmp16__length1 = self->priv->widgets_length1;
#line 109 "../src/Widgets/LabelWithWidgets.vala"
				_tmp17_ = _tmp16_[i];
#line 109 "../src/Widgets/LabelWithWidgets.vala"
				old_height = _tmp17_.height;
#line 110 "../src/Widgets/LabelWithWidgets.vala"
				if (old_width > 0) {
#line 110 "../src/Widgets/LabelWithWidgets.vala"
					_tmp18_ = TRUE;
#line 442 "LabelWithWidgets.c"
				} else {
#line 110 "../src/Widgets/LabelWithWidgets.vala"
					_tmp18_ = old_height > 0;
#line 446 "LabelWithWidgets.c"
				}
#line 110 "../src/Widgets/LabelWithWidgets.vala"
				if (_tmp18_) {
#line 450 "LabelWithWidgets.c"
					gboolean _tmp19_ = FALSE;
#line 111 "../src/Widgets/LabelWithWidgets.vala"
					if (old_width != width) {
#line 111 "../src/Widgets/LabelWithWidgets.vala"
						_tmp19_ = TRUE;
#line 456 "LabelWithWidgets.c"
					} else {
#line 111 "../src/Widgets/LabelWithWidgets.vala"
						_tmp19_ = old_height != height;
#line 460 "LabelWithWidgets.c"
					}
#line 111 "../src/Widgets/LabelWithWidgets.vala"
					if (_tmp19_) {
#line 464 "LabelWithWidgets.c"
						TubaWidgetsLabelWithWidgetsLWWWidget* _tmp20_;
						gint _tmp20__length1;
						TubaWidgetsLabelWithWidgetsLWWWidget* _tmp21_;
						gint _tmp21__length1;
#line 112 "../src/Widgets/LabelWithWidgets.vala"
						_tmp20_ = self->priv->widgets;
#line 112 "../src/Widgets/LabelWithWidgets.vala"
						_tmp20__length1 = self->priv->widgets_length1;
#line 112 "../src/Widgets/LabelWithWidgets.vala"
						_tmp20_[i].width = width;
#line 113 "../src/Widgets/LabelWithWidgets.vala"
						_tmp21_ = self->priv->widgets;
#line 113 "../src/Widgets/LabelWithWidgets.vala"
						_tmp21__length1 = self->priv->widgets_length1;
#line 113 "../src/Widgets/LabelWithWidgets.vala"
						_tmp21_[i].height = height;
#line 115 "../src/Widgets/LabelWithWidgets.vala"
						child_size_changed = TRUE;
#line 483 "LabelWithWidgets.c"
					}
				} else {
					TubaWidgetsLabelWithWidgetsLWWWidget* _tmp22_;
					gint _tmp22__length1;
					TubaWidgetsLabelWithWidgetsLWWWidget* _tmp23_;
					gint _tmp23__length1;
#line 118 "../src/Widgets/LabelWithWidgets.vala"
					_tmp22_ = self->priv->widgets;
#line 118 "../src/Widgets/LabelWithWidgets.vala"
					_tmp22__length1 = self->priv->widgets_length1;
#line 118 "../src/Widgets/LabelWithWidgets.vala"
					_tmp22_[i].width = width;
#line 119 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23_ = self->priv->widgets;
#line 119 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23__length1 = self->priv->widgets_length1;
#line 119 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23_[i].height = height;
#line 121 "../src/Widgets/LabelWithWidgets.vala"
					child_size_changed = TRUE;
#line 504 "LabelWithWidgets.c"
				}
			}
		}
	}
#line 126 "../src/Widgets/LabelWithWidgets.vala"
	if (!child_size_changed) {
#line 127 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 513 "LabelWithWidgets.c"
	}
#line 130 "../src/Widgets/LabelWithWidgets.vala"
	_tmp24_ = pango_attr_list_new ();
#line 130 "../src/Widgets/LabelWithWidgets.vala"
	attrs = _tmp24_;
#line 131 "../src/Widgets/LabelWithWidgets.vala"
	index = 0;
#line 521 "LabelWithWidgets.c"
	{
		gint i = 0;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 526 "LabelWithWidgets.c"
		{
			gboolean _tmp25_ = FALSE;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
			_tmp25_ = TRUE;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 533 "LabelWithWidgets.c"
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp27_;
				gint _tmp27__length1;
				const gchar* _tmp28_;
				PangoRectangle logical_rect = {0};
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp29_;
				gint _tmp29__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp30_;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp31_;
				gint _tmp31__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp32_;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp33_;
				gint _tmp33__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp34_;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp35_;
				gint _tmp35__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp36_;
				PangoRectangle _tmp37_ = {0};
				PangoAttribute* shape = NULL;
				PangoRectangle _tmp38_;
				PangoRectangle _tmp39_;
				PangoAttribute* _tmp40_;
				PangoAttribute* _tmp41_;
				PangoAttribute* _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				PangoAttrList* _tmp45_;
				PangoAttribute* _tmp46_;
				PangoAttribute* _tmp47_;
				gint _tmp48_;
				gint _tmp49_;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp25_) {
#line 566 "LabelWithWidgets.c"
					gint _tmp26_;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
					_tmp26_ = i;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp26_ + 1;
#line 572 "LabelWithWidgets.c"
				}
#line 133 "../src/Widgets/LabelWithWidgets.vala"
				_tmp25_ = FALSE;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
				_tmp27_ = self->priv->widgets;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
				_tmp27__length1 = self->priv->widgets_length1;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp27__length1)) {
#line 133 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 584 "LabelWithWidgets.c"
				}
#line 134 "../src/Widgets/LabelWithWidgets.vala"
				_tmp28_ = self->priv->_label_text;
#line 134 "../src/Widgets/LabelWithWidgets.vala"
				index = string_index_of (_tmp28_, TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER, index);
#line 135 "../src/Widgets/LabelWithWidgets.vala"
				if (index < 0) {
#line 135 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 594 "LabelWithWidgets.c"
				}
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp29_ = self->priv->widgets;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp29__length1 = self->priv->widgets_length1;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp30_ = _tmp29_[i];
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp31_ = self->priv->widgets;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp31__length1 = self->priv->widgets_length1;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp32_ = _tmp31_[i];
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp33_ = self->priv->widgets;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp33__length1 = self->priv->widgets_length1;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp34_ = _tmp33_[i];
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp35_ = self->priv->widgets;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp35__length1 = self->priv->widgets_length1;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp36_ = _tmp35_[i];
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				memset (&_tmp37_, 0, sizeof (PangoRectangle));
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp37_.x = 0;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp37_.y = (-(_tmp30_.height - (_tmp32_.height / 4))) * PANGO_SCALE;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp37_.width = _tmp34_.width * PANGO_SCALE;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp37_.height = _tmp36_.height * PANGO_SCALE;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				logical_rect = _tmp37_;
#line 144 "../src/Widgets/LabelWithWidgets.vala"
				_tmp38_ = logical_rect;
#line 144 "../src/Widgets/LabelWithWidgets.vala"
				_tmp39_ = logical_rect;
#line 144 "../src/Widgets/LabelWithWidgets.vala"
				_tmp40_ = pango_attr_shape_new (&_tmp38_, &_tmp39_);
#line 144 "../src/Widgets/LabelWithWidgets.vala"
				shape = _tmp40_;
#line 145 "../src/Widgets/LabelWithWidgets.vala"
				_tmp41_ = shape;
#line 145 "../src/Widgets/LabelWithWidgets.vala"
				_tmp41_->start_index = (guint) index;
#line 146 "../src/Widgets/LabelWithWidgets.vala"
				_tmp42_ = shape;
#line 146 "../src/Widgets/LabelWithWidgets.vala"
				_tmp43_ = strlen (TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 146 "../src/Widgets/LabelWithWidgets.vala"
				_tmp44_ = _tmp43_;
#line 146 "../src/Widgets/LabelWithWidgets.vala"
				_tmp42_->end_index = (guint) (index + _tmp44_);
#line 147 "../src/Widgets/LabelWithWidgets.vala"
				_tmp45_ = attrs;
#line 147 "../src/Widgets/LabelWithWidgets.vala"
				_tmp46_ = shape;
#line 147 "../src/Widgets/LabelWithWidgets.vala"
				_tmp47_ = pango_attribute_copy (_tmp46_);
#line 147 "../src/Widgets/LabelWithWidgets.vala"
				pango_attr_list_insert (_tmp45_, _tmp47_);
#line 149 "../src/Widgets/LabelWithWidgets.vala"
				_tmp48_ = strlen (TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 149 "../src/Widgets/LabelWithWidgets.vala"
				_tmp49_ = _tmp48_;
#line 149 "../src/Widgets/LabelWithWidgets.vala"
				index = index + _tmp49_;
#line 133 "../src/Widgets/LabelWithWidgets.vala"
				_pango_attribute_destroy0 (shape);
#line 668 "LabelWithWidgets.c"
			}
		}
	}
#line 152 "../src/Widgets/LabelWithWidgets.vala"
	_tmp50_ = self->label;
#line 152 "../src/Widgets/LabelWithWidgets.vala"
	_tmp51_ = attrs;
#line 152 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_attributes (_tmp50_, _tmp51_);
#line 92 "../src/Widgets/LabelWithWidgets.vala"
	_pango_attr_list_unref0 (attrs);
#line 680 "LabelWithWidgets.c"
}

static PangoLayoutRun*
_vala_PangoLayoutRun_copy (PangoLayoutRun* self)
{
#line 168 "../src/Widgets/LabelWithWidgets.vala"
	return g_boxed_copy (pango_glyph_item_get_type (), self);
#line 688 "LabelWithWidgets.c"
}

static gpointer
__vala_PangoLayoutRun_copy0 (gpointer self)
{
#line 168 "../src/Widgets/LabelWithWidgets.vala"
	return self ? _vala_PangoLayoutRun_copy (self) : NULL;
#line 696 "LabelWithWidgets.c"
}

static void
_vala_PangoLayoutRun_free (PangoLayoutRun* self)
{
#line 205 "../src/Widgets/LabelWithWidgets.vala"
	g_boxed_free (pango_glyph_item_get_type (), self);
#line 704 "LabelWithWidgets.c"
}

static void
_vala_PangoLayoutIter_free (PangoLayoutIter* self)
{
#line 155 "../src/Widgets/LabelWithWidgets.vala"
	g_boxed_free (pango_layout_iter_get_type (), self);
#line 712 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_allocate_children (TubaWidgetsLabelWithWidgets* self)
{
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp0_;
	gint _tmp0__length1;
	PangoLayoutIter* run_iter = NULL;
	GtkLabel* _tmp1_;
	PangoLayout* _tmp2_;
	PangoLayoutIter* _tmp3_;
	gint i = 0;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 155 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->widgets;
#line 156 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0__length1 = self->priv->widgets_length1;
#line 156 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp0__length1 == 0) {
#line 156 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 737 "LabelWithWidgets.c"
	}
#line 158 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->label;
#line 158 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = gtk_label_get_layout (_tmp1_);
#line 158 "../src/Widgets/LabelWithWidgets.vala"
	_tmp3_ = pango_layout_get_iter (_tmp2_);
#line 158 "../src/Widgets/LabelWithWidgets.vala"
	run_iter = _tmp3_;
#line 159 "../src/Widgets/LabelWithWidgets.vala"
	i = 0;
#line 161 "../src/Widgets/LabelWithWidgets.vala"
	_tmp4_ = tuba_widgets_label_with_widgets_get_ellipsize (self);
#line 161 "../src/Widgets/LabelWithWidgets.vala"
	_tmp5_ = _tmp4_;
#line 161 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp5_) {
#line 755 "LabelWithWidgets.c"
		TubaWidgetsLabelWithWidgetsLWWWidget* _tmp6_;
		gint _tmp6__length1;
#line 162 "../src/Widgets/LabelWithWidgets.vala"
		_tmp6_ = self->priv->widgets;
#line 162 "../src/Widgets/LabelWithWidgets.vala"
		_tmp6__length1 = self->priv->widgets_length1;
#line 762 "LabelWithWidgets.c"
		{
			TubaWidgetsLabelWithWidgetsLWWWidget* child_collection = NULL;
			gint child_collection_length1 = 0;
			gint _child_collection_size_ = 0;
			gint child_it = 0;
#line 162 "../src/Widgets/LabelWithWidgets.vala"
			child_collection = _tmp6_;
#line 162 "../src/Widgets/LabelWithWidgets.vala"
			child_collection_length1 = _tmp6__length1;
#line 162 "../src/Widgets/LabelWithWidgets.vala"
			for (child_it = 0; child_it < child_collection_length1; child_it = child_it + 1) {
#line 774 "LabelWithWidgets.c"
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp7_;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp8_ = {0};
				TubaWidgetsLabelWithWidgetsLWWWidget child = {0};
#line 162 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7_ = child_collection[child_it];
#line 162 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_lww_widget_copy (&_tmp7_, &_tmp8_);
#line 162 "../src/Widgets/LabelWithWidgets.vala"
				child = _tmp8_;
#line 784 "LabelWithWidgets.c"
				{
					TubaWidgetsLabelWithWidgetsLWWWidget _tmp9_;
					GtkWidget* _tmp10_;
#line 163 "../src/Widgets/LabelWithWidgets.vala"
					_tmp9_ = child;
#line 163 "../src/Widgets/LabelWithWidgets.vala"
					_tmp10_ = _tmp9_.widget;
#line 163 "../src/Widgets/LabelWithWidgets.vala"
					gtk_widget_set_visible (_tmp10_, FALSE);
#line 162 "../src/Widgets/LabelWithWidgets.vala"
					tuba_widgets_label_with_widgets_lww_widget_destroy (&child);
#line 796 "LabelWithWidgets.c"
				}
			}
		}
	}
#line 167 "../src/Widgets/LabelWithWidgets.vala"
	while (TRUE) {
#line 803 "LabelWithWidgets.c"
		PangoLayoutRun* run = NULL;
		PangoLayoutIter* _tmp11_;
		PangoLayoutRun* _tmp12_;
		PangoLayoutRun* _tmp13_;
		PangoLayoutRun* _tmp14_;
		PangoLayoutIter* _tmp48_;
#line 168 "../src/Widgets/LabelWithWidgets.vala"
		_tmp11_ = run_iter;
#line 168 "../src/Widgets/LabelWithWidgets.vala"
		_tmp12_ = pango_layout_iter_get_run_readonly (_tmp11_);
#line 168 "../src/Widgets/LabelWithWidgets.vala"
		_tmp13_ = __vala_PangoLayoutRun_copy0 (_tmp12_);
#line 168 "../src/Widgets/LabelWithWidgets.vala"
		run = _tmp13_;
#line 169 "../src/Widgets/LabelWithWidgets.vala"
		_tmp14_ = run;
#line 169 "../src/Widgets/LabelWithWidgets.vala"
		if (_tmp14_ != NULL) {
#line 822 "LabelWithWidgets.c"
			GSList* extra_attrs = NULL;
			PangoLayoutRun* _tmp15_;
			PangoItem* _tmp16_;
			PangoAnalysis _tmp17_;
			GSList* _tmp18_;
			GSList* _tmp19_;
			gboolean has_shape_attr = FALSE;
			GSList* _tmp20_;
#line 170 "../src/Widgets/LabelWithWidgets.vala"
			_tmp15_ = run;
#line 170 "../src/Widgets/LabelWithWidgets.vala"
			_tmp16_ = ((PangoGlyphItem*) _tmp15_)->item;
#line 170 "../src/Widgets/LabelWithWidgets.vala"
			_tmp17_ = _tmp16_->analysis;
#line 170 "../src/Widgets/LabelWithWidgets.vala"
			_tmp18_ = _tmp17_.extra_attrs;
#line 170 "../src/Widgets/LabelWithWidgets.vala"
			_tmp19_ = g_slist_copy (_tmp18_);
#line 170 "../src/Widgets/LabelWithWidgets.vala"
			extra_attrs = _tmp19_;
#line 171 "../src/Widgets/LabelWithWidgets.vala"
			has_shape_attr = FALSE;
#line 172 "../src/Widgets/LabelWithWidgets.vala"
			_tmp20_ = extra_attrs;
#line 847 "LabelWithWidgets.c"
			{
				GSList* attr_collection = NULL;
				GSList* attr_it = NULL;
#line 172 "../src/Widgets/LabelWithWidgets.vala"
				attr_collection = _tmp20_;
#line 172 "../src/Widgets/LabelWithWidgets.vala"
				for (attr_it = attr_collection; attr_it != NULL; attr_it = attr_it->next) {
#line 855 "LabelWithWidgets.c"
					void* attr = NULL;
#line 172 "../src/Widgets/LabelWithWidgets.vala"
					attr = attr_it->data;
#line 859 "LabelWithWidgets.c"
					{
						void* _tmp21_;
						PangoAttrShape* _tmp22_;
#line 173 "../src/Widgets/LabelWithWidgets.vala"
						_tmp21_ = attr;
#line 173 "../src/Widgets/LabelWithWidgets.vala"
						_tmp22_ = pango_attribute_as_shape ((PangoAttribute*) _tmp21_);
#line 173 "../src/Widgets/LabelWithWidgets.vala"
						if (_tmp22_ != NULL) {
#line 174 "../src/Widgets/LabelWithWidgets.vala"
							has_shape_attr = TRUE;
#line 175 "../src/Widgets/LabelWithWidgets.vala"
							break;
#line 873 "LabelWithWidgets.c"
						}
					}
				}
			}
#line 179 "../src/Widgets/LabelWithWidgets.vala"
			if (has_shape_attr) {
#line 880 "LabelWithWidgets.c"
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp23_;
				gint _tmp23__length1;
#line 180 "../src/Widgets/LabelWithWidgets.vala"
				_tmp23_ = self->priv->widgets;
#line 180 "../src/Widgets/LabelWithWidgets.vala"
				_tmp23__length1 = self->priv->widgets_length1;
#line 180 "../src/Widgets/LabelWithWidgets.vala"
				if (i < _tmp23__length1) {
#line 889 "LabelWithWidgets.c"
					PangoRectangle logical_rect = {0};
					PangoLayoutIter* _tmp24_;
					PangoRectangle _tmp25_ = {0};
					PangoRectangle _tmp26_;
					PangoRectangle _tmp27_;
					gint offset_x = 0;
					gint offset_y = 0;
					GtkLabel* _tmp28_;
					gint _tmp29_ = 0;
					gint _tmp30_ = 0;
					GtkAllocation allocation = {0};
					PangoRectangle _tmp31_;
					PangoRectangle _tmp32_;
					TubaWidgetsLabelWithWidgetsLWWWidget* _tmp33_;
					gint _tmp33__length1;
					TubaWidgetsLabelWithWidgetsLWWWidget _tmp34_;
					TubaWidgetsLabelWithWidgetsLWWWidget* _tmp35_;
					gint _tmp35__length1;
					TubaWidgetsLabelWithWidgetsLWWWidget _tmp36_;
					GtkAllocation _tmp37_ = {0};
					gboolean _tmp38_;
					gboolean _tmp39_;
					TubaWidgetsLabelWithWidgetsLWWWidget* _tmp43_;
					gint _tmp43__length1;
					TubaWidgetsLabelWithWidgetsLWWWidget _tmp44_;
					GtkWidget* _tmp45_;
					GtkAllocation _tmp46_;
					gint _tmp47_;
#line 182 "../src/Widgets/LabelWithWidgets.vala"
					_tmp24_ = run_iter;
#line 182 "../src/Widgets/LabelWithWidgets.vala"
					pango_layout_iter_get_run_extents (_tmp24_, NULL, &_tmp25_);
#line 182 "../src/Widgets/LabelWithWidgets.vala"
					logical_rect = _tmp25_;
#line 186 "../src/Widgets/LabelWithWidgets.vala"
					_tmp26_ = logical_rect;
#line 186 "../src/Widgets/LabelWithWidgets.vala"
					logical_rect.x = tuba_widgets_label_with_widgets_pango_pixels (self, _tmp26_.x, 0);
#line 187 "../src/Widgets/LabelWithWidgets.vala"
					_tmp27_ = logical_rect;
#line 187 "../src/Widgets/LabelWithWidgets.vala"
					logical_rect.y = tuba_widgets_label_with_widgets_pango_pixels (self, _tmp27_.y, 0);
#line 193 "../src/Widgets/LabelWithWidgets.vala"
					_tmp28_ = self->label;
#line 193 "../src/Widgets/LabelWithWidgets.vala"
					gtk_label_get_layout_offsets (_tmp28_, &_tmp29_, &_tmp30_);
#line 193 "../src/Widgets/LabelWithWidgets.vala"
					offset_x = _tmp29_;
#line 193 "../src/Widgets/LabelWithWidgets.vala"
					offset_y = _tmp30_;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp31_ = logical_rect;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp32_ = logical_rect;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp33_ = self->priv->widgets;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp33__length1 = self->priv->widgets_length1;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp34_ = _tmp33_[i];
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp35_ = self->priv->widgets;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp35__length1 = self->priv->widgets_length1;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp36_ = _tmp35_[i];
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					memset (&_tmp37_, 0, sizeof (GtkAllocation));
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp37_.x = _tmp31_.x + offset_x;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp37_.y = _tmp32_.y + offset_y;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp37_.height = _tmp34_.height;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					_tmp37_.width = _tmp36_.width;
#line 195 "../src/Widgets/LabelWithWidgets.vala"
					allocation = _tmp37_;
#line 201 "../src/Widgets/LabelWithWidgets.vala"
					_tmp38_ = tuba_widgets_label_with_widgets_get_ellipsize (self);
#line 201 "../src/Widgets/LabelWithWidgets.vala"
					_tmp39_ = _tmp38_;
#line 201 "../src/Widgets/LabelWithWidgets.vala"
					if (_tmp39_) {
#line 974 "LabelWithWidgets.c"
						TubaWidgetsLabelWithWidgetsLWWWidget* _tmp40_;
						gint _tmp40__length1;
						TubaWidgetsLabelWithWidgetsLWWWidget _tmp41_;
						GtkWidget* _tmp42_;
#line 201 "../src/Widgets/LabelWithWidgets.vala"
						_tmp40_ = self->priv->widgets;
#line 201 "../src/Widgets/LabelWithWidgets.vala"
						_tmp40__length1 = self->priv->widgets_length1;
#line 201 "../src/Widgets/LabelWithWidgets.vala"
						_tmp41_ = _tmp40_[i];
#line 201 "../src/Widgets/LabelWithWidgets.vala"
						_tmp42_ = _tmp41_.widget;
#line 201 "../src/Widgets/LabelWithWidgets.vala"
						gtk_widget_set_visible (_tmp42_, TRUE);
#line 989 "LabelWithWidgets.c"
					}
#line 202 "../src/Widgets/LabelWithWidgets.vala"
					_tmp43_ = self->priv->widgets;
#line 202 "../src/Widgets/LabelWithWidgets.vala"
					_tmp43__length1 = self->priv->widgets_length1;
#line 202 "../src/Widgets/LabelWithWidgets.vala"
					_tmp44_ = _tmp43_[i];
#line 202 "../src/Widgets/LabelWithWidgets.vala"
					_tmp45_ = _tmp44_.widget;
#line 202 "../src/Widgets/LabelWithWidgets.vala"
					_tmp46_ = allocation;
#line 202 "../src/Widgets/LabelWithWidgets.vala"
					gtk_widget_size_allocate (_tmp45_, &_tmp46_, -1);
#line 203 "../src/Widgets/LabelWithWidgets.vala"
					_tmp47_ = i;
#line 203 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp47_ + 1;
#line 1007 "LabelWithWidgets.c"
				} else {
#line 205 "../src/Widgets/LabelWithWidgets.vala"
					(extra_attrs == NULL) ? NULL : (extra_attrs = (g_slist_free (extra_attrs), NULL));
#line 205 "../src/Widgets/LabelWithWidgets.vala"
					__vala_PangoLayoutRun_free0 (run);
#line 205 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 1015 "LabelWithWidgets.c"
				}
			}
#line 169 "../src/Widgets/LabelWithWidgets.vala"
			(extra_attrs == NULL) ? NULL : (extra_attrs = (g_slist_free (extra_attrs), NULL));
#line 1020 "LabelWithWidgets.c"
		}
#line 210 "../src/Widgets/LabelWithWidgets.vala"
		_tmp48_ = run_iter;
#line 210 "../src/Widgets/LabelWithWidgets.vala"
		if (!pango_layout_iter_next_run (_tmp48_)) {
#line 211 "../src/Widgets/LabelWithWidgets.vala"
			__vala_PangoLayoutRun_free0 (run);
#line 211 "../src/Widgets/LabelWithWidgets.vala"
			break;
#line 1030 "LabelWithWidgets.c"
		}
#line 167 "../src/Widgets/LabelWithWidgets.vala"
		__vala_PangoLayoutRun_free0 (run);
#line 1034 "LabelWithWidgets.c"
	}
#line 155 "../src/Widgets/LabelWithWidgets.vala"
	__vala_PangoLayoutIter_free0 (run_iter);
#line 1038 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_size_allocate (GtkWidget* base,
                                                    gint width,
                                                    gint height,
                                                    gint baseline)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
#line 216 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 217 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 217 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp0_, width, height, baseline, NULL);
#line 218 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_children (self);
#line 1057 "LabelWithWidgets.c"
}

static GtkSizeRequestMode
tuba_widgets_label_with_widgets_real_get_request_mode (GtkWidget* base)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
	GtkSizeRequestMode result;
#line 221 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 222 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 222 "../src/Widgets/LabelWithWidgets.vala"
	result = gtk_widget_get_request_mode ((GtkWidget*) _tmp0_);
#line 222 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1074 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_measure (GtkWidget* base,
                                              GtkOrientation orientation,
                                              gint for_size,
                                              gint* minimum,
                                              gint* natural,
                                              gint* minimum_baseline,
                                              gint* natural_baseline)
{
	TubaWidgetsLabelWithWidgets * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _vala_minimum_baseline = 0;
	gint _vala_natural_baseline = 0;
	GtkLabel* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 225 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 233 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_shapes (self);
#line 234 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 234 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_measure ((GtkWidget*) _tmp0_, orientation, for_size, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 234 "../src/Widgets/LabelWithWidgets.vala"
	_vala_minimum = _tmp1_;
#line 234 "../src/Widgets/LabelWithWidgets.vala"
	_vala_natural = _tmp2_;
#line 234 "../src/Widgets/LabelWithWidgets.vala"
	_vala_minimum_baseline = _tmp3_;
#line 234 "../src/Widgets/LabelWithWidgets.vala"
	_vala_natural_baseline = _tmp4_;
#line 225 "../src/Widgets/LabelWithWidgets.vala"
	if (minimum) {
#line 225 "../src/Widgets/LabelWithWidgets.vala"
		*minimum = _vala_minimum;
#line 1116 "LabelWithWidgets.c"
	}
#line 225 "../src/Widgets/LabelWithWidgets.vala"
	if (natural) {
#line 225 "../src/Widgets/LabelWithWidgets.vala"
		*natural = _vala_natural;
#line 1122 "LabelWithWidgets.c"
	}
#line 225 "../src/Widgets/LabelWithWidgets.vala"
	if (minimum_baseline) {
#line 225 "../src/Widgets/LabelWithWidgets.vala"
		*minimum_baseline = _vala_minimum_baseline;
#line 1128 "LabelWithWidgets.c"
	}
#line 225 "../src/Widgets/LabelWithWidgets.vala"
	if (natural_baseline) {
#line 225 "../src/Widgets/LabelWithWidgets.vala"
		*natural_baseline = _vala_natural_baseline;
#line 1134 "LabelWithWidgets.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1157 "LabelWithWidgets.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1161 "LabelWithWidgets.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1167 "LabelWithWidgets.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1171 "LabelWithWidgets.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1175 "LabelWithWidgets.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1183 "LabelWithWidgets.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1211 "LabelWithWidgets.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1220 "LabelWithWidgets.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1234 "LabelWithWidgets.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1243 "LabelWithWidgets.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1257 "LabelWithWidgets.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1266 "LabelWithWidgets.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1275 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_update_label (TubaWidgetsLabelWithWidgets* self)
{
	gchar* old_label = NULL;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* new_label = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
#line 244 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 245 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 245 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 245 "../src/Widgets/LabelWithWidgets.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 245 "../src/Widgets/LabelWithWidgets.vala"
	old_label = _tmp3_;
#line 246 "../src/Widgets/LabelWithWidgets.vala"
	_tmp4_ = self->priv->_text;
#line 246 "../src/Widgets/LabelWithWidgets.vala"
	_tmp5_ = tuba_widgets_label_with_widgets_get_placeholder (self);
#line 246 "../src/Widgets/LabelWithWidgets.vala"
	_tmp6_ = _tmp5_;
#line 246 "../src/Widgets/LabelWithWidgets.vala"
	_tmp7_ = string_replace (_tmp4_, _tmp6_, TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 246 "../src/Widgets/LabelWithWidgets.vala"
	new_label = _tmp7_;
#line 248 "../src/Widgets/LabelWithWidgets.vala"
	if (self->priv->_fix_overflow_hack) {
#line 1317 "LabelWithWidgets.c"
		GtkLabel* _tmp8_;
		TubaWidgetsLabelWithWidgetsLWWWidget* _tmp9_;
		gint _tmp9__length1;
		GtkLabel* _tmp10_;
		GtkLabel* _tmp11_;
#line 249 "../src/Widgets/LabelWithWidgets.vala"
		_tmp8_ = self->label;
#line 249 "../src/Widgets/LabelWithWidgets.vala"
		_tmp9_ = self->priv->widgets;
#line 249 "../src/Widgets/LabelWithWidgets.vala"
		_tmp9__length1 = self->priv->widgets_length1;
#line 249 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_lines (_tmp8_, MAX (100, _tmp9__length1));
#line 250 "../src/Widgets/LabelWithWidgets.vala"
		_tmp10_ = self->label;
#line 250 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_ellipsize (_tmp10_, PANGO_ELLIPSIZE_END);
#line 251 "../src/Widgets/LabelWithWidgets.vala"
		_tmp11_ = self->label;
#line 251 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_width_chars (_tmp11_, 1);
#line 1339 "LabelWithWidgets.c"
	}
#line 254 "../src/Widgets/LabelWithWidgets.vala"
	_tmp12_ = old_label;
#line 254 "../src/Widgets/LabelWithWidgets.vala"
	_tmp13_ = new_label;
#line 254 "../src/Widgets/LabelWithWidgets.vala"
	if (g_strcmp0 (_tmp12_, _tmp13_) != 0) {
#line 1347 "LabelWithWidgets.c"
		GtkLabel* _tmp14_;
		GtkLabel* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		GtkLabel* _tmp18_;
		const gchar* _tmp19_;
		GtkLabel* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
#line 255 "../src/Widgets/LabelWithWidgets.vala"
		_tmp14_ = self->label;
#line 255 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_wrap (_tmp14_, TRUE);
#line 256 "../src/Widgets/LabelWithWidgets.vala"
		_tmp15_ = self->label;
#line 256 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_wrap_mode (_tmp15_, PANGO_WRAP_WORD_CHAR);
#line 258 "../src/Widgets/LabelWithWidgets.vala"
		_tmp16_ = new_label;
#line 258 "../src/Widgets/LabelWithWidgets.vala"
		_tmp17_ = g_strdup (_tmp16_);
#line 258 "../src/Widgets/LabelWithWidgets.vala"
		_g_free0 (self->priv->_text);
#line 258 "../src/Widgets/LabelWithWidgets.vala"
		self->priv->_text = _tmp17_;
#line 259 "../src/Widgets/LabelWithWidgets.vala"
		_tmp18_ = self->label;
#line 259 "../src/Widgets/LabelWithWidgets.vala"
		_tmp19_ = self->priv->_text;
#line 259 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_label (_tmp18_, _tmp19_);
#line 260 "../src/Widgets/LabelWithWidgets.vala"
		_tmp20_ = self->label;
#line 260 "../src/Widgets/LabelWithWidgets.vala"
		_tmp21_ = gtk_label_get_text (_tmp20_);
#line 260 "../src/Widgets/LabelWithWidgets.vala"
		_tmp22_ = g_strdup (_tmp21_);
#line 260 "../src/Widgets/LabelWithWidgets.vala"
		_g_free0 (self->priv->_label_text);
#line 260 "../src/Widgets/LabelWithWidgets.vala"
		self->priv->_label_text = _tmp22_;
#line 261 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_update_accessible_label (self);
#line 262 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_invalidate_child_widgets (self);
#line 1393 "LabelWithWidgets.c"
	}
#line 244 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (new_label);
#line 244 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (old_label);
#line 1399 "LabelWithWidgets.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 279 "../src/Widgets/LabelWithWidgets.vala"
	return self ? g_object_ref (self) : NULL;
#line 1407 "LabelWithWidgets.c"
}

static gchar*
string_splice (const gchar* self,
               glong start,
               glong end,
               const gchar* str)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gsize str_size = 0UL;
	const gchar* _result_ = NULL;
	void* _tmp6_;
	gchar* dest = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* result;
#line 1548 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1549 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1549 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1549 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1550 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1551 "glib-2.0.vapi"
		start = string_length + start;
#line 1443 "LabelWithWidgets.c"
	}
#line 1553 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1554 "glib-2.0.vapi"
		end = string_length + end;
#line 1449 "LabelWithWidgets.c"
	}
#line 1556 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1556 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1455 "LabelWithWidgets.c"
	} else {
#line 1556 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1459 "LabelWithWidgets.c"
	}
#line 1556 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1557 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1557 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1467 "LabelWithWidgets.c"
	} else {
#line 1557 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1471 "LabelWithWidgets.c"
	}
#line 1557 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1558 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1561 "glib-2.0.vapi"
	if (str == NULL) {
#line 1562 "glib-2.0.vapi"
		str_size = (gsize) 0;
#line 1481 "LabelWithWidgets.c"
	} else {
		gint _tmp4_;
		gint _tmp5_;
#line 1564 "glib-2.0.vapi"
		_tmp4_ = strlen ((const gchar*) str);
#line 1564 "glib-2.0.vapi"
		_tmp5_ = _tmp4_;
#line 1564 "glib-2.0.vapi"
		str_size = (gsize) _tmp5_;
#line 1491 "LabelWithWidgets.c"
	}
#line 1567 "glib-2.0.vapi"
	_tmp6_ = g_malloc0 (((string_length - (end - start)) + str_size) + 1);
#line 1567 "glib-2.0.vapi"
	_result_ = _tmp6_;
#line 1569 "glib-2.0.vapi"
	_tmp7_ = _result_;
#line 1569 "glib-2.0.vapi"
	dest = (gchar*) _tmp7_;
#line 1571 "glib-2.0.vapi"
	_tmp8_ = dest;
#line 1571 "glib-2.0.vapi"
	memcpy (_tmp8_, self, (gsize) start);
#line 1572 "glib-2.0.vapi"
	_tmp9_ = dest;
#line 1572 "glib-2.0.vapi"
	dest = _tmp9_ + start;
#line 1574 "glib-2.0.vapi"
	if (str != NULL) {
#line 1511 "LabelWithWidgets.c"
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1575 "glib-2.0.vapi"
		_tmp10_ = dest;
#line 1575 "glib-2.0.vapi"
		memcpy (_tmp10_, str, str_size);
#line 1576 "glib-2.0.vapi"
		_tmp11_ = dest;
#line 1576 "glib-2.0.vapi"
		dest = _tmp11_ + str_size;
#line 1522 "LabelWithWidgets.c"
	}
#line 1579 "glib-2.0.vapi"
	_tmp12_ = dest;
#line 1579 "glib-2.0.vapi"
	memcpy (_tmp12_, ((gchar*) self) + end, (gsize) (string_length - end));
#line 1581 "glib-2.0.vapi"
	_tmp13_ = _result_;
#line 1581 "glib-2.0.vapi"
	_result_ = NULL;
#line 1581 "glib-2.0.vapi"
	result = (gchar*) _tmp13_;
#line 1581 "glib-2.0.vapi"
	return result;
#line 1536 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_update_accessible_label (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* _tmp0_;
	gint index_of_obj = 0;
	const gchar* _tmp24_;
#line 267 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 268 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_label_text;
#line 268 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_set_accessible_text (self, _tmp0_);
#line 270 "../src/Widgets/LabelWithWidgets.vala"
	index_of_obj = 0;
#line 1553 "LabelWithWidgets.c"
	{
		gint i = 0;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 1558 "LabelWithWidgets.c"
		{
			gboolean _tmp1_ = FALSE;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
			_tmp1_ = TRUE;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 1565 "LabelWithWidgets.c"
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp3_;
				gint _tmp3__length1;
				const gchar* _tmp4_;
				gint original_index_of_obj = 0;
				gint _tmp5_;
				gint _tmp6_;
				GtkWidget* child_widget = NULL;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp7_;
				gint _tmp7__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp8_;
				GtkWidget* _tmp9_;
				GtkWidget* _tmp10_;
				gboolean _tmp11_ = FALSE;
				GtkWidget* _tmp12_;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp18_;
				GtkWidget* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp1_) {
#line 1590 "LabelWithWidgets.c"
					gint _tmp2_;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
					_tmp2_ = i;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp2_ + 1;
#line 1596 "LabelWithWidgets.c"
				}
#line 271 "../src/Widgets/LabelWithWidgets.vala"
				_tmp1_ = FALSE;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = self->priv->widgets;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3__length1 = self->priv->widgets_length1;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp3__length1)) {
#line 271 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 1608 "LabelWithWidgets.c"
				}
#line 272 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = self->priv->_accessible_text;
#line 272 "../src/Widgets/LabelWithWidgets.vala"
				index_of_obj = string_index_of (_tmp4_, TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER, index_of_obj);
#line 273 "../src/Widgets/LabelWithWidgets.vala"
				if (index_of_obj == -1) {
#line 273 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 1618 "LabelWithWidgets.c"
				}
#line 276 "../src/Widgets/LabelWithWidgets.vala"
				original_index_of_obj = index_of_obj;
#line 277 "../src/Widgets/LabelWithWidgets.vala"
				_tmp5_ = strlen (TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 277 "../src/Widgets/LabelWithWidgets.vala"
				_tmp6_ = _tmp5_;
#line 277 "../src/Widgets/LabelWithWidgets.vala"
				index_of_obj += _tmp6_;
#line 279 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7_ = self->priv->widgets;
#line 279 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7__length1 = self->priv->widgets_length1;
#line 279 "../src/Widgets/LabelWithWidgets.vala"
				_tmp8_ = _tmp7_[i];
#line 279 "../src/Widgets/LabelWithWidgets.vala"
				_tmp9_ = _tmp8_.widget;
#line 279 "../src/Widgets/LabelWithWidgets.vala"
				_tmp10_ = _g_object_ref0 (_tmp9_);
#line 279 "../src/Widgets/LabelWithWidgets.vala"
				child_widget = _tmp10_;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
				_tmp12_ = child_widget;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
				_tmp13_ = gtk_widget_get_tooltip_text (_tmp12_);
#line 280 "../src/Widgets/LabelWithWidgets.vala"
				_tmp14_ = _tmp13_;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
				if (_tmp14_ == NULL) {
#line 280 "../src/Widgets/LabelWithWidgets.vala"
					_tmp11_ = TRUE;
#line 1650 "LabelWithWidgets.c"
				} else {
					GtkWidget* _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
					_tmp15_ = child_widget;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
					_tmp16_ = gtk_widget_get_tooltip_text (_tmp15_);
#line 280 "../src/Widgets/LabelWithWidgets.vala"
					_tmp17_ = _tmp16_;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
					_tmp11_ = g_strcmp0 (_tmp17_, "") == 0;
#line 1663 "LabelWithWidgets.c"
				}
#line 280 "../src/Widgets/LabelWithWidgets.vala"
				if (_tmp11_) {
#line 280 "../src/Widgets/LabelWithWidgets.vala"
					_g_object_unref0 (child_widget);
#line 280 "../src/Widgets/LabelWithWidgets.vala"
					continue;
#line 1671 "LabelWithWidgets.c"
				}
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_tmp18_ = self->priv->_accessible_text;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_tmp19_ = child_widget;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_tmp20_ = gtk_widget_get_tooltip_text (_tmp19_);
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_tmp21_ = _tmp20_;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_tmp22_ = string_splice (_tmp18_, (glong) original_index_of_obj, (glong) index_of_obj, _tmp21_);
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_tmp23_ = _tmp22_;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_set_accessible_text (self, _tmp23_);
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_g_free0 (_tmp23_);
#line 271 "../src/Widgets/LabelWithWidgets.vala"
				_g_object_unref0 (child_widget);
#line 1691 "LabelWithWidgets.c"
			}
		}
	}
#line 285 "../src/Widgets/LabelWithWidgets.vala"
	_tmp24_ = self->priv->_accessible_text;
#line 285 "../src/Widgets/LabelWithWidgets.vala"
	gtk_accessible_update_property ((GtkAccessible*) self, GTK_ACCESSIBLE_PROPERTY_LABEL, _tmp24_, -1, -1);
#line 1699 "LabelWithWidgets.c"
}

static void
_vala_array_add72 (TubaWidgetsLabelWithWidgetsLWWWidget* * array,
                   gint* length,
                   gint* size,
                   const TubaWidgetsLabelWithWidgetsLWWWidget* value)
{
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	if ((*length) == (*size)) {
#line 289 "../src/Widgets/LabelWithWidgets.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 289 "../src/Widgets/LabelWithWidgets.vala"
		*array = g_renew (TubaWidgetsLabelWithWidgetsLWWWidget, *array, *size);
#line 1714 "LabelWithWidgets.c"
	}
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	(*array)[(*length)++] = *value;
#line 1718 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_append_child (TubaWidgetsLabelWithWidgets* self,
                                              GtkWidget* child)
{
	GtkWidget* _tmp0_;
	TubaWidgetsLabelWithWidgetsLWWWidget _tmp1_ = {0};
#line 288 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 288 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (child != NULL);
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = _g_object_ref0 (child);
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	memset (&_tmp1_, 0, sizeof (TubaWidgetsLabelWithWidgetsLWWWidget));
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (_tmp1_.widget);
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_.widget = _tmp0_;
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_.width = 0;
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_.height = 0;
#line 289 "../src/Widgets/LabelWithWidgets.vala"
	_vala_array_add72 (&self->priv->widgets, &self->priv->widgets_length1, &self->priv->_widgets_size_, &_tmp1_);
#line 294 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_parent (child, (GtkWidget*) self);
#line 295 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_invalidate_child_widgets (self);
#line 1749 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_construct_with_label_and_widgets (GType object_type,
                                                                  const gchar* t_text,
                                                                  GtkWidget** t_widgets,
                                                                  gint t_widgets_length1)
{
	TubaWidgetsLabelWithWidgets * self = NULL;
#line 298 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (t_text != NULL, NULL);
#line 299 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) g_object_new (object_type, NULL);
#line 1763 "LabelWithWidgets.c"
	{
		GtkWidget** widget_collection = NULL;
		gint widget_collection_length1 = 0;
		gint _widget_collection_size_ = 0;
		gint widget_it = 0;
#line 301 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection = t_widgets;
#line 301 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection_length1 = t_widgets_length1;
#line 301 "../src/Widgets/LabelWithWidgets.vala"
		for (widget_it = 0; widget_it < widget_collection_length1; widget_it = widget_it + 1) {
#line 1775 "LabelWithWidgets.c"
			GtkWidget* widget = NULL;
#line 301 "../src/Widgets/LabelWithWidgets.vala"
			widget = widget_collection[widget_it];
#line 1779 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp0_;
#line 302 "../src/Widgets/LabelWithWidgets.vala"
				_tmp0_ = widget;
#line 302 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_append_child (self, _tmp0_);
#line 1786 "LabelWithWidgets.c"
			}
		}
	}
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_set_text (self, t_text);
#line 298 "../src/Widgets/LabelWithWidgets.vala"
	return self;
#line 1794 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_new_with_label_and_widgets (const gchar* t_text,
                                                            GtkWidget** t_widgets,
                                                            gint t_widgets_length1)
{
#line 298 "../src/Widgets/LabelWithWidgets.vala"
	return tuba_widgets_label_with_widgets_construct_with_label_and_widgets (TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, t_text, t_widgets, t_widgets_length1);
#line 1804 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_children (TubaWidgetsLabelWithWidgets* self,
                                              GtkWidget** t_widgets,
                                              gint t_widgets_length1)
{
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp0_;
	gint _tmp0__length1;
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp7_;
#line 308 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->widgets;
#line 309 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0__length1 = self->priv->widgets_length1;
#line 1821 "LabelWithWidgets.c"
	{
		TubaWidgetsLabelWithWidgetsLWWWidget* child_collection = NULL;
		gint child_collection_length1 = 0;
		gint _child_collection_size_ = 0;
		gint child_it = 0;
#line 309 "../src/Widgets/LabelWithWidgets.vala"
		child_collection = _tmp0_;
#line 309 "../src/Widgets/LabelWithWidgets.vala"
		child_collection_length1 = _tmp0__length1;
#line 309 "../src/Widgets/LabelWithWidgets.vala"
		for (child_it = 0; child_it < child_collection_length1; child_it = child_it + 1) {
#line 1833 "LabelWithWidgets.c"
			TubaWidgetsLabelWithWidgetsLWWWidget _tmp1_;
			TubaWidgetsLabelWithWidgetsLWWWidget _tmp2_ = {0};
			TubaWidgetsLabelWithWidgetsLWWWidget child = {0};
#line 309 "../src/Widgets/LabelWithWidgets.vala"
			_tmp1_ = child_collection[child_it];
#line 309 "../src/Widgets/LabelWithWidgets.vala"
			tuba_widgets_label_with_widgets_lww_widget_copy (&_tmp1_, &_tmp2_);
#line 309 "../src/Widgets/LabelWithWidgets.vala"
			child = _tmp2_;
#line 1843 "LabelWithWidgets.c"
			{
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp3_;
				GtkWidget* _tmp4_;
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp5_;
				GtkWidget* _tmp6_;
#line 310 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = child;
#line 310 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = _tmp3_.widget;
#line 310 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_unparent (_tmp4_);
#line 311 "../src/Widgets/LabelWithWidgets.vala"
				_tmp5_ = child;
#line 311 "../src/Widgets/LabelWithWidgets.vala"
				_tmp6_ = _tmp5_.widget;
#line 311 "../src/Widgets/LabelWithWidgets.vala"
				g_signal_emit_by_name (_tmp6_, "destroy");
#line 309 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_lww_widget_destroy (&child);
#line 1863 "LabelWithWidgets.c"
			}
		}
	}
#line 313 "../src/Widgets/LabelWithWidgets.vala"
	_tmp7_ = g_new0 (TubaWidgetsLabelWithWidgetsLWWWidget, 0);
#line 313 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = (_vala_TubaWidgetsLabelWithWidgetsLWWWidget_array_free (self->priv->widgets, self->priv->widgets_length1), NULL);
#line 313 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = _tmp7_;
#line 313 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets_length1 = 0;
#line 313 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widgets_size_ = self->priv->widgets_length1;
#line 1877 "LabelWithWidgets.c"
	{
		GtkWidget** widget_collection = NULL;
		gint widget_collection_length1 = 0;
		gint _widget_collection_size_ = 0;
		gint widget_it = 0;
#line 314 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection = t_widgets;
#line 314 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection_length1 = t_widgets_length1;
#line 314 "../src/Widgets/LabelWithWidgets.vala"
		for (widget_it = 0; widget_it < widget_collection_length1; widget_it = widget_it + 1) {
#line 1889 "LabelWithWidgets.c"
			GtkWidget* widget = NULL;
#line 314 "../src/Widgets/LabelWithWidgets.vala"
			widget = widget_collection[widget_it];
#line 1893 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp8_;
#line 315 "../src/Widgets/LabelWithWidgets.vala"
				_tmp8_ = widget;
#line 315 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_append_child (self, _tmp8_);
#line 1900 "LabelWithWidgets.c"
			}
		}
	}
}

static void
tuba_widgets_label_with_widgets_invalidate_child_widgets (TubaWidgetsLabelWithWidgets* self)
{
#line 319 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 1911 "LabelWithWidgets.c"
	{
		gint i = 0;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 1916 "LabelWithWidgets.c"
		{
			gboolean _tmp0_ = FALSE;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
			_tmp0_ = TRUE;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 1923 "LabelWithWidgets.c"
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp2_;
				gint _tmp2__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp3_;
				gint _tmp3__length1;
				TubaWidgetsLabelWithWidgetsLWWWidget* _tmp4_;
				gint _tmp4__length1;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp0_) {
#line 1932 "LabelWithWidgets.c"
					gint _tmp1_;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
					_tmp1_ = i;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp1_ + 1;
#line 1938 "LabelWithWidgets.c"
				}
#line 320 "../src/Widgets/LabelWithWidgets.vala"
				_tmp0_ = FALSE;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2_ = self->priv->widgets;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2__length1 = self->priv->widgets_length1;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp2__length1)) {
#line 320 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 1950 "LabelWithWidgets.c"
				}
#line 321 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = self->priv->widgets;
#line 321 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3__length1 = self->priv->widgets_length1;
#line 321 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_[i].width = 0;
#line 322 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = self->priv->widgets;
#line 322 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4__length1 = self->priv->widgets_length1;
#line 322 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_[i].height = 0;
#line 1964 "LabelWithWidgets.c"
			}
		}
	}
#line 324 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_shapes (self);
#line 325 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 1972 "LabelWithWidgets.c"
}

static gint
tuba_widgets_label_with_widgets_pango_pixels (TubaWidgetsLabelWithWidgets* self,
                                              gint d,
                                              gint a)
{
	gint result;
#line 328 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 329 "../src/Widgets/LabelWithWidgets.vala"
	result = (d + a) >> 10;
#line 329 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1987 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_add_child (GtkBuildable* base,
                                                GtkBuilder* builder,
                                                GObject* child,
                                                const gchar* type)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 332 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 332 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (builder != NULL);
#line 332 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (child != NULL);
#line 333 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_widget_get_type ()) ? ((GtkWidget*) child) : NULL);
#line 333 "../src/Widgets/LabelWithWidgets.vala"
	widget = _tmp0_;
#line 334 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = widget;
#line 334 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp1_ != NULL) {
#line 2014 "LabelWithWidgets.c"
		GtkWidget* _tmp2_;
#line 335 "../src/Widgets/LabelWithWidgets.vala"
		_tmp2_ = widget;
#line 335 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_append_child (self, _tmp2_);
#line 2020 "LabelWithWidgets.c"
	} else {
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
#line 337 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 337 "../src/Widgets/LabelWithWidgets.vala"
		_tmp4_ = _tmp3_;
#line 337 "../src/Widgets/LabelWithWidgets.vala"
		G_TYPE_INSTANCE_GET_INTERFACE ((GtkBuildable*) _tmp4_, gtk_buildable_get_type (), GtkBuildableIface)->add_child ((GtkBuildable*) _tmp4_, builder, child, type);
#line 2030 "LabelWithWidgets.c"
	}
#line 340 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_buildable_parent_iface->add_child ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), builder, child, type);
#line 332 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (widget);
#line 2036 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_grab_focus (TubaWidgetsLabelWithWidgets* self)
{
	GtkLabel* _tmp0_;
	gboolean result;
#line 343 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 344 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 344 "../src/Widgets/LabelWithWidgets.vala"
	result = gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 344 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2052 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_construct (GType object_type)
{
	TubaWidgetsLabelWithWidgets * self = NULL;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) g_object_new (object_type, NULL);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	return self;
#line 2063 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_new (void)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	return tuba_widgets_label_with_widgets_construct (TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS);
#line 2071 "LabelWithWidgets.c"
}

const gchar*
tuba_widgets_label_with_widgets_get_placeholder (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 22 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_placeholder;
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2087 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_placeholder (TubaWidgetsLabelWithWidgets* self,
                                                 const gchar* value)
{
	gchar* _tmp0_;
#line 25 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_strdup (value);
#line 26 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_placeholder);
#line 26 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_placeholder = _tmp0_;
#line 27 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 25 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY]);
#line 2107 "LabelWithWidgets.c"
}

const gchar*
tuba_widgets_label_with_widgets_get_text (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_text;
#line 35 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 35 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2123 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_text (TubaWidgetsLabelWithWidgets* self,
                                          const gchar* value)
{
	gchar* _tmp0_;
	GtkLabel* _tmp1_;
#line 37 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_strdup (value);
#line 38 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_text);
#line 38 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_text = _tmp0_;
#line 39 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 40 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->label;
#line 40 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify ((GObject*) _tmp1_, "label");
#line 37 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY]);
#line 2148 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_use_markup (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
#line 46 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "../src/Widgets/LabelWithWidgets.vala"
	result = self->priv->_use_markup;
#line 47 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2161 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_use_markup (TubaWidgetsLabelWithWidgets* self,
                                                gboolean value)
{
	GtkLabel* _tmp0_;
#line 49 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Widgets/LabelWithWidgets.vala"
	if (self->priv->_use_markup == value) {
#line 50 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 2175 "LabelWithWidgets.c"
	}
#line 52 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_use_markup = value;
#line 53 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 53 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_use_markup (_tmp0_, self->priv->_use_markup);
#line 49 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY]);
#line 2185 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_fix_overflow_hack (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
#line 59 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	result = self->priv->_fix_overflow_hack;
#line 60 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2198 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_fix_overflow_hack (TubaWidgetsLabelWithWidgets* self,
                                                       gboolean value)
{
#line 62 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_fix_overflow_hack = value;
#line 64 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 62 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_FIX_OVERFLOW_HACK_PROPERTY]);
#line 2213 "LabelWithWidgets.c"
}

const gchar*
tuba_widgets_label_with_widgets_get_accessible_text (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_accessible_text;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2229 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_set_accessible_text (TubaWidgetsLabelWithWidgets* self,
                                                     const gchar* value)
{
	gchar* old_value;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	old_value = tuba_widgets_label_with_widgets_get_accessible_text (self);
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2243 "LabelWithWidgets.c"
		gchar* _tmp0_;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
		_tmp0_ = g_strdup (value);
#line 266 "../src/Widgets/LabelWithWidgets.vala"
		_g_free0 (self->priv->_accessible_text);
#line 266 "../src/Widgets/LabelWithWidgets.vala"
		self->priv->_accessible_text = _tmp0_;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
		g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACCESSIBLE_TEXT_PROPERTY]);
#line 2253 "LabelWithWidgets.c"
	}
}

const gchar*
tuba_widgets_label_with_widgets_get_label_text (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 350 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 351 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_label_text;
#line 351 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 351 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2270 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_single_line_mode (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 356 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 356 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 356 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_single_line_mode (_tmp0_);
#line 356 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 356 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 356 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2292 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_single_line_mode (TubaWidgetsLabelWithWidgets* self,
                                                      gboolean value)
{
	GtkLabel* _tmp0_;
#line 357 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 357 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_single_line_mode (_tmp0_, value);
#line 357 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY]);
#line 2308 "LabelWithWidgets.c"
}

gfloat
tuba_widgets_label_with_widgets_get_xalign (TubaWidgetsLabelWithWidgets* self)
{
	gfloat result;
	GtkLabel* _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
#line 361 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 361 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 361 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_xalign (_tmp0_);
#line 361 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 361 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 361 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2330 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_xalign (TubaWidgetsLabelWithWidgets* self,
                                            gfloat value)
{
	GtkLabel* _tmp0_;
#line 362 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 362 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 362 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_xalign (_tmp0_, value);
#line 362 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY]);
#line 2346 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_selectable (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 366 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 366 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 366 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_selectable (_tmp0_);
#line 366 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 366 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 366 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2368 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_selectable (TubaWidgetsLabelWithWidgets* self,
                                                gboolean value)
{
	GtkLabel* _tmp0_;
#line 367 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 367 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 367 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_selectable (_tmp0_, value);
#line 367 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY]);
#line 2384 "LabelWithWidgets.c"
}

gint
tuba_widgets_label_with_widgets_get_lines (TubaWidgetsLabelWithWidgets* self)
{
	gint result;
	GtkLabel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 371 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 371 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 371 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_lines (_tmp0_);
#line 371 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 371 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 371 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2406 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_lines (TubaWidgetsLabelWithWidgets* self,
                                           gint value)
{
	GtkLabel* _tmp0_;
#line 372 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 372 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 372 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_lines (_tmp0_, value);
#line 372 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY]);
#line 2422 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_ellipsize (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
#line 377 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 377 "../src/Widgets/LabelWithWidgets.vala"
	result = self->priv->_ellipsize;
#line 377 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2435 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_ellipsize (TubaWidgetsLabelWithWidgets* self,
                                               gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 378 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 379 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = tuba_widgets_label_with_widgets_get_ellipsize (self);
#line 379 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = _tmp0_;
#line 379 "../src/Widgets/LabelWithWidgets.vala"
	if (value != _tmp1_) {
#line 2452 "LabelWithWidgets.c"
		PangoEllipsizeMode _tmp2_ = 0;
		GtkLabel* _tmp3_;
#line 380 "../src/Widgets/LabelWithWidgets.vala"
		if (value) {
#line 380 "../src/Widgets/LabelWithWidgets.vala"
			_tmp2_ = PANGO_ELLIPSIZE_END;
#line 2459 "LabelWithWidgets.c"
		} else {
#line 380 "../src/Widgets/LabelWithWidgets.vala"
			_tmp2_ = PANGO_ELLIPSIZE_NONE;
#line 2463 "LabelWithWidgets.c"
		}
#line 380 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = self->label;
#line 380 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_ellipsize (_tmp3_, _tmp2_);
#line 381 "../src/Widgets/LabelWithWidgets.vala"
		self->priv->_ellipsize = TRUE;
#line 2471 "LabelWithWidgets.c"
	}
#line 378 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY]);
#line 2475 "LabelWithWidgets.c"
}

GtkJustification
tuba_widgets_label_with_widgets_get_justify (TubaWidgetsLabelWithWidgets* self)
{
	GtkJustification result;
	GtkLabel* _tmp0_;
	GtkJustification _tmp1_;
	GtkJustification _tmp2_;
#line 387 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 387 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 387 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_justify (_tmp0_);
#line 387 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 387 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 387 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2497 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_justify (TubaWidgetsLabelWithWidgets* self,
                                             GtkJustification value)
{
	GtkLabel* _tmp0_;
#line 388 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 388 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 388 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_justify (_tmp0_, value);
#line 388 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY]);
#line 2513 "LabelWithWidgets.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__STRING (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__STRING) (gpointer data1, const char* arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (return_value != NULL);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (n_param_values == 2);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data1 = closure->data;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data2 = param_values->data[0].v_pointer;
#line 2541 "LabelWithWidgets.c"
	} else {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data1 = param_values->data[0].v_pointer;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data2 = closure->data;
#line 2547 "LabelWithWidgets.c"
	}
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	callback = (GMarshalFunc_BOOLEAN__STRING) (marshal_data ? marshal_data : cc->callback);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	v_return = callback (data1, g_value_get_string (param_values + 1), data2);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_value_set_boolean (return_value, v_return);
#line 2555 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_lww_widget_copy (const TubaWidgetsLabelWithWidgetsLWWWidget* self,
                                                 TubaWidgetsLabelWithWidgetsLWWWidget* dest)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = (*self).widget;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 ((*dest).widget);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	(*dest).widget = _tmp1_;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	(*dest).height = (*self).height;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	(*dest).width = (*self).width;
#line 2576 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_lww_widget_destroy (TubaWidgetsLabelWithWidgetsLWWWidget* self)
{
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 ((*self).widget);
#line 2584 "LabelWithWidgets.c"
}

static TubaWidgetsLabelWithWidgetsLWWWidget*
tuba_widgets_label_with_widgets_lww_widget_dup (const TubaWidgetsLabelWithWidgetsLWWWidget* self)
{
	TubaWidgetsLabelWithWidgetsLWWWidget* dup;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	dup = g_new0 (TubaWidgetsLabelWithWidgetsLWWWidget, 1);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_lww_widget_copy (self, dup);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	return dup;
#line 2597 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_lww_widget_free (TubaWidgetsLabelWithWidgetsLWWWidget* self)
{
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_lww_widget_destroy (self);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	g_free (self);
#line 2607 "LabelWithWidgets.c"
}

 G_GNUC_NO_INLINE static GType
tuba_widgets_label_with_widgets_lww_widget_get_type_once (void)
{
	GType tuba_widgets_label_with_widgets_lww_widget_type_id;
	tuba_widgets_label_with_widgets_lww_widget_type_id = g_boxed_type_register_static ("TubaWidgetsLabelWithWidgetsLWWWidget", (GBoxedCopyFunc) tuba_widgets_label_with_widgets_lww_widget_dup, (GBoxedFreeFunc) tuba_widgets_label_with_widgets_lww_widget_free);
	return tuba_widgets_label_with_widgets_lww_widget_type_id;
}

static GType
tuba_widgets_label_with_widgets_lww_widget_get_type (void)
{
	static gsize tuba_widgets_label_with_widgets_lww_widget_type_id__once = 0;
	if (g_once_init_enter (&tuba_widgets_label_with_widgets_lww_widget_type_id__once)) {
		GType tuba_widgets_label_with_widgets_lww_widget_type_id;
		tuba_widgets_label_with_widgets_lww_widget_type_id = tuba_widgets_label_with_widgets_lww_widget_get_type_once ();
		g_once_init_leave (&tuba_widgets_label_with_widgets_lww_widget_type_id__once, tuba_widgets_label_with_widgets_lww_widget_type_id);
	}
	return tuba_widgets_label_with_widgets_lww_widget_type_id__once;
}

static gboolean
_tuba_widgets_label_with_widgets___lambda27_ (TubaWidgetsLabelWithWidgets* self,
                                              const gchar* url)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 83 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (url != NULL, FALSE);
#line 83 "../src/Widgets/LabelWithWidgets.vala"
	g_signal_emit (self, tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL], 0, url, &_tmp0_);
#line 83 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 83 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2644 "LabelWithWidgets.c"
}

static gboolean
__tuba_widgets_label_with_widgets___lambda27__gtk_label_activate_link (GtkLabel* _sender,
                                                                       const gchar* uri,
                                                                       gpointer self)
{
	gboolean result;
	result = _tuba_widgets_label_with_widgets___lambda27_ ((TubaWidgetsLabelWithWidgets*) self, uri);
#line 83 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2656 "LabelWithWidgets.c"
}

static GObject *
tuba_widgets_label_with_widgets_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
#line 70 "../src/Widgets/LabelWithWidgets.vala"
	parent_class = G_OBJECT_CLASS (tuba_widgets_label_with_widgets_parent_class);
#line 70 "../src/Widgets/LabelWithWidgets.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 70 "../src/Widgets/LabelWithWidgets.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 71 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new ("");
#line 71 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_wrap (_tmp0_, TRUE);
#line 71 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_wrap_mode (_tmp0_, PANGO_WRAP_WORD_CHAR);
#line 71 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_xalign (_tmp0_, 0.0f);
#line 71 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
#line 71 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_use_markup (_tmp0_, FALSE);
#line 71 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_ellipsize (_tmp0_, PANGO_ELLIPSIZE_NONE);
#line 71 "../src/Widgets/LabelWithWidgets.vala"
	g_object_ref_sink (_tmp0_);
#line 71 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (self->label);
#line 71 "../src/Widgets/LabelWithWidgets.vala"
	self->label = _tmp0_;
#line 81 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->label;
#line 81 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp1_, (GtkWidget*) self);
#line 83 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = self->label;
#line 83 "../src/Widgets/LabelWithWidgets.vala"
	g_signal_connect_object (_tmp2_, "activate-link", (GCallback) __tuba_widgets_label_with_widgets___lambda27__gtk_label_activate_link, self, 0);
#line 70 "../src/Widgets/LabelWithWidgets.vala"
	return obj;
#line 2706 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_class_init (TubaWidgetsLabelWithWidgetsClass * klass,
                                            gpointer klass_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_type_class_adjust_private_offset (klass, &TubaWidgetsLabelWithWidgets_private_offset);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) tuba_widgets_label_with_widgets_real_size_allocate;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) tuba_widgets_label_with_widgets_real_get_request_mode;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->measure = (void (*) (GtkWidget*, GtkOrientation, gint, gint*, gint*, gint*, gint*)) tuba_widgets_label_with_widgets_real_measure;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuba_widgets_label_with_widgets_get_property;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuba_widgets_label_with_widgets_set_property;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->constructor = tuba_widgets_label_with_widgets_constructor;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->finalize = tuba_widgets_label_with_widgets_finalize;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY] = g_param_spec_string ("placeholder", "placeholder", "placeholder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY] = g_param_spec_boolean ("use-markup", "use-markup", "use-markup", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_FIX_OVERFLOW_HACK_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_FIX_OVERFLOW_HACK_PROPERTY] = g_param_spec_boolean ("fix-overflow-hack", "fix-overflow-hack", "fix-overflow-hack", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACCESSIBLE_TEXT_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACCESSIBLE_TEXT_PROPERTY] = g_param_spec_string ("accessible-text", "accessible-text", "accessible-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_LABEL_TEXT_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_LABEL_TEXT_PROPERTY] = g_param_spec_string ("label-text", "label-text", "label-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY] = g_param_spec_boolean ("single-line-mode", "single-line-mode", "single-line-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY] = g_param_spec_float ("xalign", "xalign", "xalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY] = g_param_spec_boolean ("selectable", "selectable", "selectable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY] = g_param_spec_int ("lines", "lines", "lines", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY] = g_param_spec_boolean ("ellipsize", "ellipsize", "ellipsize", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY] = g_param_spec_enum ("justify", "justify", "justify", gtk_justification_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL] = g_signal_new ("activate-link", TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__STRING, G_TYPE_BOOLEAN, 1, G_TYPE_STRING);
#line 2757 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                              gpointer iface_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) tuba_widgets_label_with_widgets_real_add_child;
#line 2768 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_gtk_accessible_interface_init (GtkAccessibleInterface * iface,
                                                               gpointer iface_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_accessible_parent_iface = g_type_interface_peek_parent (iface);
#line 2777 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_instance_init (TubaWidgetsLabelWithWidgets * self,
                                               gpointer klass)
{
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self->priv = tuba_widgets_label_with_widgets_get_instance_private (self);
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_new0 (TubaWidgetsLabelWithWidgetsLWWWidget, 0);
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = _tmp0_;
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets_length1 = 0;
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widgets_size_ = self->priv->widgets_length1;
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = g_strdup ("<widget>");
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_placeholder = _tmp1_;
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = g_strdup ("");
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_label_text = _tmp2_;
#line 32 "../src/Widgets/LabelWithWidgets.vala"
	_tmp3_ = g_strdup ("");
#line 32 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_text = _tmp3_;
#line 44 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_use_markup = FALSE;
#line 57 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_fix_overflow_hack = FALSE;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	_tmp4_ = g_strdup ("");
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_accessible_text = _tmp4_;
#line 375 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_ellipsize = FALSE;
#line 2821 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_finalize (GObject * obj)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
	TubaWidgetsLabelWithWidgetsLWWWidget* _tmp1_;
	gint _tmp1__length1;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 86 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 86 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 87 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->priv->widgets;
#line 87 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1__length1 = self->priv->widgets_length1;
#line 2841 "LabelWithWidgets.c"
	{
		TubaWidgetsLabelWithWidgetsLWWWidget* child_collection = NULL;
		gint child_collection_length1 = 0;
		gint _child_collection_size_ = 0;
		gint child_it = 0;
#line 87 "../src/Widgets/LabelWithWidgets.vala"
		child_collection = _tmp1_;
#line 87 "../src/Widgets/LabelWithWidgets.vala"
		child_collection_length1 = _tmp1__length1;
#line 87 "../src/Widgets/LabelWithWidgets.vala"
		for (child_it = 0; child_it < child_collection_length1; child_it = child_it + 1) {
#line 2853 "LabelWithWidgets.c"
			TubaWidgetsLabelWithWidgetsLWWWidget _tmp2_;
			TubaWidgetsLabelWithWidgetsLWWWidget _tmp3_ = {0};
			TubaWidgetsLabelWithWidgetsLWWWidget child = {0};
#line 87 "../src/Widgets/LabelWithWidgets.vala"
			_tmp2_ = child_collection[child_it];
#line 87 "../src/Widgets/LabelWithWidgets.vala"
			tuba_widgets_label_with_widgets_lww_widget_copy (&_tmp2_, &_tmp3_);
#line 87 "../src/Widgets/LabelWithWidgets.vala"
			child = _tmp3_;
#line 2863 "LabelWithWidgets.c"
			{
				TubaWidgetsLabelWithWidgetsLWWWidget _tmp4_;
				GtkWidget* _tmp5_;
#line 88 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = child;
#line 88 "../src/Widgets/LabelWithWidgets.vala"
				_tmp5_ = _tmp4_.widget;
#line 88 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_unparent (_tmp5_);
#line 87 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_lww_widget_destroy (&child);
#line 2875 "LabelWithWidgets.c"
			}
		}
	}
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = (_vala_TubaWidgetsLabelWithWidgetsLWWWidget_array_free (self->priv->widgets, self->priv->widgets_length1), NULL);
#line 18 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (self->label);
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_placeholder);
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_label_text);
#line 32 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_text);
#line 266 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_accessible_text);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (tuba_widgets_label_with_widgets_parent_class)->finalize (obj);
#line 2893 "LabelWithWidgets.c"
}

 G_GNUC_NO_INLINE static GType
tuba_widgets_label_with_widgets_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TubaWidgetsLabelWithWidgetsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuba_widgets_label_with_widgets_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TubaWidgetsLabelWithWidgets), 0, (GInstanceInitFunc) tuba_widgets_label_with_widgets_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) tuba_widgets_label_with_widgets_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gtk_accessible_info = { (GInterfaceInitFunc) tuba_widgets_label_with_widgets_gtk_accessible_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType tuba_widgets_label_with_widgets_type_id;
	tuba_widgets_label_with_widgets_type_id = g_type_register_static (gtk_widget_get_type (), "TubaWidgetsLabelWithWidgets", &g_define_type_info, 0);
	g_type_add_interface_static (tuba_widgets_label_with_widgets_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	g_type_add_interface_static (tuba_widgets_label_with_widgets_type_id, gtk_accessible_get_type (), &gtk_accessible_info);
	TubaWidgetsLabelWithWidgets_private_offset = g_type_add_instance_private (tuba_widgets_label_with_widgets_type_id, sizeof (TubaWidgetsLabelWithWidgetsPrivate));
	return tuba_widgets_label_with_widgets_type_id;
}

GType
tuba_widgets_label_with_widgets_get_type (void)
{
	static gsize tuba_widgets_label_with_widgets_type_id__once = 0;
	if (g_once_init_enter (&tuba_widgets_label_with_widgets_type_id__once)) {
		GType tuba_widgets_label_with_widgets_type_id;
		tuba_widgets_label_with_widgets_type_id = tuba_widgets_label_with_widgets_get_type_once ();
		g_once_init_leave (&tuba_widgets_label_with_widgets_type_id__once, tuba_widgets_label_with_widgets_type_id);
	}
	return tuba_widgets_label_with_widgets_type_id__once;
}

static void
_vala_tuba_widgets_label_with_widgets_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	TubaWidgetsLabelWithWidgets * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	switch (property_id) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_string (value, tuba_widgets_label_with_widgets_get_placeholder (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_string (value, tuba_widgets_label_with_widgets_get_text (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_use_markup (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_FIX_OVERFLOW_HACK_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_fix_overflow_hack (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACCESSIBLE_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_string (value, tuba_widgets_label_with_widgets_get_accessible_text (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_LABEL_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_string (value, tuba_widgets_label_with_widgets_get_label_text (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_single_line_mode (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_float (value, tuba_widgets_label_with_widgets_get_xalign (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_selectable (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_int (value, tuba_widgets_label_with_widgets_get_lines (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_ellipsize (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_enum (value, tuba_widgets_label_with_widgets_get_justify (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 3004 "LabelWithWidgets.c"
		default:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 3010 "LabelWithWidgets.c"
	}
}

static void
_vala_tuba_widgets_label_with_widgets_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	TubaWidgetsLabelWithWidgets * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	switch (property_id) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_placeholder (self, g_value_get_string (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_text (self, g_value_get_string (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_use_markup (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_FIX_OVERFLOW_HACK_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_fix_overflow_hack (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACCESSIBLE_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_accessible_text (self, g_value_get_string (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_single_line_mode (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_xalign (self, g_value_get_float (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_selectable (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_lines (self, g_value_get_int (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_ellipsize (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_justify (self, g_value_get_enum (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 3090 "LabelWithWidgets.c"
		default:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 3096 "LabelWithWidgets.c"
	}
}

